# Class JTextComponent

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.text.JTextComponent

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, Scrollable`

Direct Known Subclasses:
  `JEditorPane, JTextArea, JTextField`

@JavaBean(defaultProperty="UI") public abstract class JTextComponent extends JComponent implements Scrollable, Accessible
`JTextComponent` is the base class for swing text components. It tries to be compatible with the `java.awt.TextComponent` class where it can reasonably do so. Also provided are other services for additional flexibility (beyond the pluggable UI and bean support). You can find information on how to use the functionality this class provides in General Rules for Using Text Components, a section in The Java Tutorial.

Caret Changes
  The caret is a pluggable object in swing text components. Notification of changes to the caret position and the selection are sent to implementations of the `CaretListener` interface that have been registered with the text component. The UI will install a default caret unless a customized caret has been set.
  By default the caret tracks all the document changes performed on the Event Dispatching Thread and updates it's position accordingly if an insertion occurs before or at the caret position or a removal occurs before the caret position. `DefaultCaret` tries to make itself visible which may lead to scrolling of a text component within `JScrollPane`. The default caret behavior can be changed by the `DefaultCaret.setUpdatePolicy(int)` method.
  Note: Non-editable text components also have a caret though it may not be painted.
Commands
  Text components provide a number of commands that can be used to manipulate the component. This is essentially the way that the component expresses its capabilities. These are expressed in terms of the swing `Action` interface, using the `TextAction` implementation. The set of commands supported by the text component can be found with the `getActions()` method. These actions can be bound to key events, fired from buttons, etc.
Text Input
  The text components support flexible and internationalized text input, using keymaps and the input method framework, while maintaining compatibility with the AWT listener model.

  A `Keymap` lets an application bind key strokes to actions. In order to allow keymaps to be shared across multiple text components, they can use actions that extend `TextAction`. `TextAction` can determine which `JTextComponent` most recently has or had focus and therefore is the subject of the action (In the case that the `ActionEvent` sent to the action doesn't contain the target text component as its source).

  The Input Method Framework lets text components interact with input methods, separate software components that preprocess events to let users enter thousands of different characters using keyboards with far fewer keys. `JTextComponent` is an active client of the framework, so it implements the preferred user interface for interacting with input methods. As a consequence, some key events do not reach the text component because they are handled by an input method, and some text input reaches the text component as committed text within an `InputMethodEvent` instead of as a key event. The complete text input is the combination of the characters in `keyTyped` key events and committed text in input method events.

  The AWT listener model lets applications attach event listeners to components in order to bind events to actions. Swing encourages the use of keymaps instead of listeners, but maintains compatibility with listeners by giving the listeners a chance to steal an event by consuming it.

  Keyboard event and input method events are handled in the following stages, with each stage capable of consuming the event:

  Stages of keyboard and input method event handling
  Stage | KeyEvent | InputMethodEvent
  --- | --- | ---
  1. | input methods | (generated here)
  2. | focus manager |
  3. | registered key listeners | registered input method listeners
  4. |  | input method handling in JTextComponent
  5. | keymap handling using the current keymap
  6. | keyboard handling in JComponent (e.g. accelerators, component navigation, etc.) |

  To maintain compatibility with applications that listen to key events but are not aware of input method events, the input method handling in stage 4 provides a compatibility mode for components that do not process input method events. For these components, the committed text is converted to keyTyped key events and processed in the key event pipeline starting at stage 3 instead of in the input method event pipeline.

  By default the component will create a keymap (named DEFAULT_KEYMAP) that is shared by all JTextComponent instances as the default keymap. Typically a look-and-feel implementation will install a different keymap that resolves to the default keymap for those bindings not found in the different keymap. The minimal bindings include:

  - inserting content into the editor for the printable keys.
  - removing content with the backspace and del keys.
  - caret movement forward and backward
Model/View Split
  The text components have a model-view split. A text component pulls together the objects used to represent the model, view, and controller. The text document model may be shared by other views which act as observers of the model (e.g. a document may be shared by multiple components).

  The model is defined by the `Document` interface. This is intended to provide a flexible text storage mechanism that tracks change during edits and can be extended to more sophisticated models. The model interfaces are meant to capture the capabilities of expression given by SGML, a system used to express a wide variety of content. Each modification to the document causes notification of the details of the change to be sent to all observers in the form of a `DocumentEvent` which allows the views to stay up to date with the model. This event is sent to observers that have implemented the `DocumentListener` interface and registered interest with the model being observed.

Location Information
  The capability of determining the location of text in the view is provided. There are two methods, `modelToView(int)` and `viewToModel(Point)` for determining this information.
Undo/Redo support
  Support for an edit history mechanism is provided to allow undo/redo operations. The text component does not itself provide the history buffer by default, but does provide the `UndoableEdit` records that can be used in conjunction with a history buffer to provide the undo/redo support. The support is provided by the Document model, which allows one to attach UndoableEditListener implementations.
Thread Safety
  The swing text components provide some support of thread safe operations. Because of the high level of configurability of the text components, it is possible to circumvent the protection provided. The protection primarily comes from the model, so the documentation of `AbstractDocument` describes the assumptions of the protection provided. The methods that are safe to call asynchronously are marked with comments.
Newlines
  For a discussion on how newlines are handled, see DefaultEditorKit.
Printing support
  Several `print` methods are provided for basic document printing. If more advanced printing is needed, use the `getPrintable(MessageFormat, MessageFormat)` method.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

See Also:
  - `Document`
  - `DocumentEvent`
  - `DocumentListener`
  - `Caret`
  - `CaretEvent`
  - `CaretListener`
  - `TextUI`
  - `View`
  - `ViewFactory`

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`JTextComponent.AccessibleJTextComponent`
This class implements accessibility support for the `JTextComponent` class.
`static final class`
`JTextComponent.DropLocation`
Represents a drop location for `JTextComponent`s.
`static class`
`JTextComponent.KeyBinding`
Binding record for creating key bindings.

### Nested classes/interfaces declared in class JComponent

`JComponent.AccessibleJComponent`
Modifier and Type
Class
Description
`class`
`JComponent.AccessibleJComponent`
Inner class of JComponent used to provide default support for accessibility.

### Nested classes/interfaces declared in class Container

`Container.AccessibleAWTContainer`
Modifier and Type
Class
Description
`protected class`
`Container.AccessibleAWTContainer`
Inner class of Container used to provide default support for accessibility.

### Nested classes/interfaces declared in class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
Modifier and Type
Class
Description
`protected class`
`Component.AccessibleAWTComponent`
Inner class of Component used to provide default support for accessibility.
`static enum`
`Component.BaselineResizeBehavior`
Enumeration of the common ways the baseline of a component can change as the size changes.
`protected class`
`Component.BltBufferStrategy`
Inner class for blitting offscreen surfaces to a component.
`protected class`
`Component.FlipBufferStrategy`
Inner class for flipping buffers on a component.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_KEYMAP`
The default keymap that will be shared by all `JTextComponent` instances unless they have had a different keymap set.
`static final String`
`FOCUS_ACCELERATOR_KEY`
The bound property name for the focus accelerator.

### Fields declared in class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`
Modifier and Type
Field
Description
`protected EventListenerList`
`listenerList`
A list of event listeners for this component.
`static final String`
`TOOL_TIP_TEXT_KEY`
The comment to display when the cursor is over the component, also known as a "value tip", "flyover help", or "flyover label".
`protected ComponentUI`
`ui`
The look and feel delegate for this component.
`static final int`
`UNDEFINED_CONDITION`
Constant used by some of the APIs to mean that no condition is defined.
`static final int`
`WHEN_ANCESTOR_OF_FOCUSED_COMPONENT`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is an ancestor of the focused component or is itself the focused component.
`static final int`
`WHEN_FOCUSED`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the component has the focus.
`static final int`
`WHEN_IN_FOCUSED_WINDOW`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is in the window that has the focus or is itself the focused component.

### Fields declared in class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
Modifier and Type
Field
Description
`protected AccessibleContext`
`accessibleContext`
The `AccessibleContext` associated with this `Component`.
`static final float`
`BOTTOM_ALIGNMENT`
Ease-of-use constant for `getAlignmentY`.
`static final float`
`CENTER_ALIGNMENT`
Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static final float`
`LEFT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`RIGHT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`TOP_ALIGNMENT`
Ease-of-use constant for `getAlignmentY()`.

### Fields declared in interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
Modifier and Type
Field
Description
`static final int`
`ABORT`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
`static final int`
`ALLBITS`
This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
`static final int`
`ERROR`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
`static final int`
`FRAMEBITS`
This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
`static final int`
`HEIGHT`
This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
`static final int`
`PROPERTIES`
This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
`static final int`
`SOMEBITS`
This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
`static final int`
`WIDTH`
This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

## Constructor Summary

Constructors
Constructor
Description
`JTextComponent()`
Creates a new `JTextComponent`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addCaretListener(CaretListener listener)`
Adds a caret listener for notification of any changes to the caret.
`static Keymap`
`addKeymap(String nm, Keymap parent)`
Adds a new keymap into the keymap hierarchy.
`void`
`copy()`
Transfers the currently selected range in the associated text model to the system clipboard, leaving the contents in the text model.
`void`
`cut()`
Transfers the currently selected range in the associated text model to the system clipboard, removing the contents from the model.
`protected void`
`fireCaretUpdate(CaretEvent e)`
Notifies all listeners that have registered interest for notification on this event type.
`AccessibleContext`
`getAccessibleContext()`
Gets the `AccessibleContext` associated with this `JTextComponent`.
`Action[]`
`getActions()`
Fetches the command list for the editor.
`Caret`
`getCaret()`
Fetches the caret that allows text-oriented navigation over the view.
`Color`
`getCaretColor()`
Fetches the current color used to render the caret.
`CaretListener[]`
`getCaretListeners()`
Returns an array of all the caret listeners registered on this text component.
`int`
`getCaretPosition()`
Returns the position of the text insertion caret for the text component.
`Color`
`getDisabledTextColor()`
Fetches the current color used to render the disabled text.
`Document`
`getDocument()`
Fetches the model associated with the editor.
`boolean`
`getDragEnabled()`
Returns whether or not automatic drag handling is enabled.
`final JTextComponent.DropLocation`
`getDropLocation()`
Returns the location that this component should visually indicate as the drop location during a DnD operation over the component, or `null` if no location is to currently be shown.
`final DropMode`
`getDropMode()`
Returns the drop mode for this component.
`char`
`getFocusAccelerator()`
Returns the key accelerator that will cause the receiving text component to get the focus.
`Highlighter`
`getHighlighter()`
Fetches the object responsible for making highlights.
`InputMethodRequests`
`getInputMethodRequests()`
Gets the input method request handler which supports requests from input methods for this component.
`Keymap`
`getKeymap()`
Fetches the keymap currently active in this text component.
`static Keymap`
`getKeymap(String nm)`
Fetches a named keymap previously added to the document.
`Insets`
`getMargin()`
Returns the margin between the text component's border and its text.
`NavigationFilter`
`getNavigationFilter()`
Returns the `NavigationFilter`.
`Dimension`
`getPreferredScrollableViewportSize()`
Returns the preferred size of the viewport for a view component.
`Printable`
`getPrintable(MessageFormat headerFormat, MessageFormat footerFormat)`
Returns a `Printable` to use for printing the content of this `JTextComponent`.
`int`
`getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction)`
Components that display logical rows or columns should compute the scroll increment that will completely expose one block of rows or columns, depending on the value of orientation.
`boolean`
`getScrollableTracksViewportHeight()`
Returns true if a viewport should always force the height of this `Scrollable` to match the height of the viewport.
`boolean`
`getScrollableTracksViewportWidth()`
Returns true if a viewport should always force the width of this `Scrollable` to match the width of the viewport.
`int`
`getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction)`
Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation.
`String`
`getSelectedText()`
Returns the selected text contained in this `TextComponent`.
`Color`
`getSelectedTextColor()`
Fetches the current color used to render the selected text.
`Color`
`getSelectionColor()`
Fetches the current color used to render the selection.
`int`
`getSelectionEnd()`
Returns the selected text's end position.
`int`
`getSelectionStart()`
Returns the selected text's start position.
`String`
`getText()`
Returns the text contained in this `TextComponent`.
`String`
`getText(int offs, int len)`
Fetches a portion of the text represented by the component.
`String`
`getToolTipText(MouseEvent event)`
Returns the string to be used as the tooltip for `event`.
`TextUI`
`getUI()`
Fetches the user-interface factory for this text-oriented editor.
`boolean`
`isEditable()`
Returns the boolean indicating whether this `TextComponent` is editable or not.
`static void`
`loadKeymap(Keymap map, JTextComponent.KeyBinding[] bindings, Action[] actions)`
Loads a keymap with a bunch of bindings.
`Rectangle`
`modelToView(int pos)`
Deprecated.
replaced by `modelToView2D(int)`
`Rectangle2D`
`modelToView2D(int pos)`
Converts the given location in the model to a place in the view coordinate system.
`void`
`moveCaretPosition(int pos)`
Moves the caret to a new position, leaving behind a mark defined by the last time `setCaretPosition` was called.
`protected String`
`paramString()`
Returns a string representation of this `JTextComponent`.
`void`
`paste()`
Transfers the contents of the system clipboard into the associated text model.
`boolean`
`print()`
A convenience print method that displays a print dialog, and then prints this `JTextComponent` in interactive mode with no header or footer text.
`boolean`
`print(MessageFormat headerFormat, MessageFormat footerFormat)`
A convenience print method that displays a print dialog, and then prints this `JTextComponent` in interactive mode with the specified header and footer text.
`boolean`
`print(MessageFormat headerFormat, MessageFormat footerFormat, boolean showPrintDialog, PrintService service, PrintRequestAttributeSet attributes, boolean interactive)`
Prints the content of this `JTextComponent`.
`void`
`read(Reader in, Object desc)`
Initializes from a stream.
`void`
`removeCaretListener(CaretListener listener)`
Removes a caret listener.
`static Keymap`
`removeKeymap(String nm)`
Removes a named keymap previously added to the document.
`void`
`replaceSelection(String content)`
Replaces the currently selected content with new content represented by the given string.
`protected void`
`restoreComposedText()`
Restores composed text previously saved by `saveComposedText`.
`protected boolean`
`saveComposedText(int pos)`
Saves composed text around the specified position.
`void`
`select(int selectionStart, int selectionEnd)`
Selects the text between the specified start and end positions.
`void`
`selectAll()`
Selects all the text in the `TextComponent`.
`void`
`setCaret(Caret c)`
Sets the caret to be used.
`void`
`setCaretColor(Color c)`
Sets the current color used to render the caret.
`void`
`setCaretPosition(int position)`
Sets the position of the text insertion caret for the `TextComponent`.
`void`
`setDisabledTextColor(Color c)`
Sets the current color used to render the disabled text.
`void`
`setDocument(Document doc)`
Associates the editor with a text document.
`void`
`setDragEnabled(boolean b)`
Turns on or off automatic drag handling.
`final void`
`setDropMode(DropMode dropMode)`
Sets the drop mode for this component.
`void`
`setEditable(boolean b)`
Sets the specified boolean to indicate whether or not this `TextComponent` should be editable.
`void`
`setFocusAccelerator(char aKey)`
Sets the key accelerator that will cause the receiving text component to get the focus.
`void`
`setHighlighter(Highlighter h)`
Sets the highlighter to be used.
`void`
`setKeymap(Keymap map)`
Sets the keymap to use for binding events to actions.
`void`
`setMargin(Insets m)`
Sets margin space between the text component's border and its text.
`void`
`setNavigationFilter(NavigationFilter filter)`
Sets the `NavigationFilter`.
`void`
`setSelectedTextColor(Color c)`
Sets the current color used to render the selected text.
`void`
`setSelectionColor(Color c)`
Sets the current color used to render the selection.
`void`
`setSelectionEnd(int selectionEnd)`
Sets the selection end to the specified position.
`void`
`setSelectionStart(int selectionStart)`
Sets the selection start to the specified position.
`void`
`setText(String t)`
Sets the text of this `TextComponent` to the specified text.
`void`
`setUI(TextUI ui)`
Sets the user-interface factory for this text-oriented editor.
`void`
`updateUI()`
Reloads the pluggable UI.
`int`
`viewToModel(Point pt)`
Deprecated.
replaced by `viewToModel2D(Point2D)`
`int`
`viewToModel2D(Point2D pt)`
Converts the given place in the view coordinate system to the nearest representative location in the model.
`void`
`write(Writer out)`
Stores the contents of the model into the given stream.

### Methods declared in class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`
Modifier and Type
Method
Description
`void`
`addAncestorListener(AncestorListener listener)`
Registers `listener` so that it will receive `AncestorEvents` when it or any of its ancestors move or are made visible or invisible.
`void`
`addNotify()`
Notifies this component that it now has a parent component.
`void`
`addVetoableChangeListener(VetoableChangeListener listener)`
Adds a `VetoableChangeListener` to the listener list.
`void`
`computeVisibleRect(Rectangle visibleRect)`
Returns the `Component`'s "visible rect rectangle" - the intersection of the visible rectangles for this component and all of its ancestors.
`boolean`
`contains(int x, int y)`
Gives the UI delegate an opportunity to define the precise shape of this component for the sake of mouse processing.
`JToolTip`
`createToolTip()`
Returns the instance of `JToolTip` that should be used to display the tooltip.
`void`
`disable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`enable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
Support for reporting bound property changes for boolean properties.
`void`
`firePropertyChange(String propertyName, int oldValue, int newValue)`
Support for reporting bound property changes for integer properties.
`protected void`
`fireVetoableChange(String propertyName, Object oldValue, Object newValue)`
Supports reporting constrained property changes.
`ActionListener`
`getActionForKeyStroke(KeyStroke aKeyStroke)`
Returns the object that will perform the action registered for a given keystroke.
`final ActionMap`
`getActionMap()`
Returns the `ActionMap` used to determine what `Action` to fire for particular `KeyStroke` binding.
`float`
`getAlignmentX()`
Overrides `Container.getAlignmentX` to return the horizontal alignment.
`float`
`getAlignmentY()`
Overrides `Container.getAlignmentY` to return the vertical alignment.
`AncestorListener[]`
`getAncestorListeners()`
Returns an array of all the ancestor listeners registered on this component.
`boolean`
`getAutoscrolls()`
Gets the `autoscrolls` property.
`int`
`getBaseline(int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior()`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Border`
`getBorder()`
Returns the border of this component or `null` if no border is currently set.
`Rectangle`
`getBounds(Rectangle rv)`
Stores the bounds of this component into "return value" `rv` and returns `rv`.
`final Object`
`getClientProperty(Object key)`
Returns the value of the property with the specified key.
`protected Graphics`
`getComponentGraphics(Graphics g)`
Returns the graphics object used to paint this component.
`JPopupMenu`
`getComponentPopupMenu()`
Returns `JPopupMenu` that assigned for this component.
`int`
`getConditionForKeyStroke(KeyStroke aKeyStroke)`
Returns the condition that determines whether a registered action occurs in response to the specified keystroke.
`int`
`getDebugGraphicsOptions()`
Returns the state of graphics debugging.
`static Locale`
`getDefaultLocale()`
Returns the default locale used to initialize each JComponent's locale property upon creation.
`FontMetrics`
`getFontMetrics(Font font)`
Gets the `FontMetrics` for the specified `Font`.
`Graphics`
`getGraphics()`
Returns this component's graphics context, which lets you draw on a component.
`int`
`getHeight()`
Returns the current height of this component.
`boolean`
`getInheritsPopupMenu()`
Returns true if the JPopupMenu should be inherited from the parent.
`final InputMap`
`getInputMap()`
Returns the `InputMap` that is used when the component has focus.
`final InputMap`
`getInputMap(int condition)`
Returns the `InputMap` that is used during `condition`.
`InputVerifier`
`getInputVerifier()`
Returns the input verifier for this component.
`Insets`
`getInsets()`
If a border has been set on this component, returns the border's insets; otherwise calls `super.getInsets`.
`Insets`
`getInsets(Insets insets)`
Returns an `Insets` object containing this component's inset values.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of all the objects currently registered as `FooListener`s upon this `JComponent`.
`Point`
`getLocation(Point rv)`
Stores the x,y origin of this component into "return value" `rv` and returns `rv`.
`Dimension`
`getMaximumSize()`
If the maximum size has been set to a non-`null` value just returns it.
`Dimension`
`getMinimumSize()`
If the minimum size has been set to a non-`null` value just returns it.
`Component`
`getNextFocusableComponent()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`.
`Point`
`getPopupLocation(MouseEvent event)`
Returns the preferred location to display the popup menu in this component's coordinate system.
`Dimension`
`getPreferredSize()`
If the `preferredSize` has been set to a non-`null` value just returns it.
`KeyStroke[]`
`getRegisteredKeyStrokes()`
Returns the `KeyStrokes` that will initiate registered actions.
`JRootPane`
`getRootPane()`
Returns the `JRootPane` ancestor for this component.
`Dimension`
`getSize(Dimension rv)`
Stores the width/height of this component into "return value" `rv` and returns `rv`.
`Point`
`getToolTipLocation(MouseEvent event)`
Returns the tooltip location in this component's coordinate system.
`String`
`getToolTipText()`
Returns the tooltip string that has been set with `setToolTipText`.
`Container`
`getTopLevelAncestor()`
Returns the top-level ancestor of this component (the containing `Window`) or `null` if this component has not been added to any container.
`TransferHandler`
`getTransferHandler()`
Gets the `transferHandler` property.
`String`
`getUIClassID()`
Returns the `UIDefaults` key used to look up the name of the `swing.plaf.ComponentUI` class that defines the look and feel for this component.
`boolean`
`getVerifyInputWhenFocusTarget()`
Returns the value that indicates whether the input verifier for the current focus owner will be called before this component requests focus.
`VetoableChangeListener[]`
`getVetoableChangeListeners()`
Returns an array of all the vetoable change listeners registered on this component.
`Rectangle`
`getVisibleRect()`
Returns the `Component`'s "visible rectangle" - the intersection of this component's visible rectangle, `new Rectangle(0, 0, getWidth(), getHeight())`, and all of its ancestors' visible rectangles.
`int`
`getWidth()`
Returns the current width of this component.
`int`
`getX()`
Returns the current x coordinate of the component's origin.
`int`
`getY()`
Returns the current y coordinate of the component's origin.
`void`
`grabFocus()`
Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`void`
`hide()`
Deprecated.
`boolean`
`isDoubleBuffered()`
Returns whether this component should use a buffer to paint.
`static boolean`
`isLightweightComponent(Component c)`
Returns true if this component is lightweight, that is, if it doesn't have a native window system peer.
`boolean`
`isManagingFocus()`
Deprecated.
As of 1.4, replaced by `Component.setFocusTraversalKeys(int, Set)` and `Container.setFocusCycleRoot(boolean)`.
`boolean`
`isOpaque()`
Returns true if this component is completely opaque.
`boolean`
`isOptimizedDrawingEnabled()`
Returns true if this component tiles its children -- that is, if it can guarantee that the children will not overlap.
`final boolean`
`isPaintingForPrint()`
Returns `true` if the current painting operation on this component is part of a `print` operation.
`protected boolean`
`isPaintingOrigin()`
Returns `true` if a paint triggered on a child component should cause painting to originate from this Component, or one of its ancestors.
`boolean`
`isPaintingTile()`
Returns true if the component is currently painting a tile.
`boolean`
`isRequestFocusEnabled()`
Returns `true` if this `JComponent` should get focus; otherwise returns `false`.
`boolean`
`isValidateRoot()`
If this method returns true, `revalidate` calls by descendants of this component will cause the entire tree beginning with this root to be validated.
`void`
`paint(Graphics g)`
Invoked by Swing to draw components.
`protected void`
`paintBorder(Graphics g)`
Paints the component's border.
`protected void`
`paintChildren(Graphics g)`
Paints this component's children.
`protected void`
`paintComponent(Graphics g)`
Calls the UI delegate's paint method, if the UI delegate is non-`null`.
`void`
`paintImmediately(int x, int y, int w, int h)`
Paints the specified region in this component and all of its descendants that overlap the region, immediately.
`void`
`paintImmediately(Rectangle r)`
Paints the specified region now.
`void`
`print(Graphics g)`
Invoke this method to print the component to the specified `Graphics`.
`void`
`printAll(Graphics g)`
Invoke this method to print the component.
`protected void`
`printBorder(Graphics g)`
Prints the component's border.
`protected void`
`printChildren(Graphics g)`
Prints this component's children.
`protected void`
`printComponent(Graphics g)`
This is invoked during a printing operation.
`protected void`
`processComponentKeyEvent(KeyEvent e)`
Processes any key events that the component itself recognizes.
`protected boolean`
`processKeyBinding(KeyStroke ks, KeyEvent e, int condition, boolean pressed)`
Invoked to process the key bindings for `ks` as the result of the `KeyEvent` `e`.
`protected void`
`processKeyEvent(KeyEvent e)`
Overrides `processKeyEvent` to process events.
`protected void`
`processMouseEvent(MouseEvent e)`
Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects, refer to `Component.processMouseEvent(MouseEvent)` for a complete description of this method.
`protected void`
`processMouseMotionEvent(MouseEvent e)`
Processes mouse motion events, such as MouseEvent.MOUSE_DRAGGED.
`final void`
`putClientProperty(Object key, Object value)`
Adds an arbitrary key/value "client property" to this component.
`void`
`registerKeyboardAction(ActionListener anAction, String aCommand, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`registerKeyboardAction(ActionListener anAction, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`removeAncestorListener(AncestorListener listener)`
Unregisters `listener` so that it will no longer receive `AncestorEvents`.
`void`
`removeNotify()`
Notifies this component that it no longer has a parent component.
`void`
`removeVetoableChangeListener(VetoableChangeListener listener)`
Removes a `VetoableChangeListener` from the listener list.
`void`
`repaint(long tm, int x, int y, int width, int height)`
Adds the specified region to the dirty region list if the component is showing.
`void`
`repaint(Rectangle r)`
Adds the specified region to the dirty region list if the component is showing.
`boolean`
`requestDefaultFocus()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy.getDefaultComponent(Container).requestFocus()`
`void`
`requestFocus()`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocus(boolean temporary)`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocusInWindow()`
Requests that this `Component` gets the input focus.
`protected boolean`
`requestFocusInWindow(boolean temporary)`
Requests that this `Component` gets the input focus.
`void`
`resetKeyboardActions()`
Unregisters all the bindings in the first tier `InputMaps` and `ActionMap`.
`void`
`reshape(int x, int y, int w, int h)`
Deprecated.
As of JDK 5, replaced by `Component.setBounds(int, int, int, int)`.
`void`
`revalidate()`
Supports deferred automatic layout.
`void`
`scrollRectToVisible(Rectangle aRect)`
Forwards the `scrollRectToVisible()` message to the `JComponent`'s parent.
`final void`
`setActionMap(ActionMap am)`
Sets the `ActionMap` to `am`.
`void`
`setAlignmentX(float alignmentX)`
Sets the horizontal alignment.
`void`
`setAlignmentY(float alignmentY)`
Sets the vertical alignment.
`void`
`setAutoscrolls(boolean autoscrolls)`
Sets the `autoscrolls` property.
`void`
`setBackground(Color bg)`
Sets the background color of this component.
`void`
`setBorder(Border border)`
Sets the border of this component.
`void`
`setComponentPopupMenu(JPopupMenu popup)`
Sets the `JPopupMenu` for this `JComponent`.
`void`
`setDebugGraphicsOptions(int debugOptions)`
Enables or disables diagnostic information about every graphics operation performed within the component or one of its children.
`static void`
`setDefaultLocale(Locale l)`
Sets the default locale used to initialize each JComponent's locale property upon creation.
`void`
`setDoubleBuffered(boolean aFlag)`
Sets whether this component should use a buffer to paint.
`void`
`setEnabled(boolean enabled)`
Sets whether or not this component is enabled.
`void`
`setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
Sets the focus traversal keys for a given traversal operation for this Component.
`void`
`setFont(Font font)`
Sets the font for this component.
`void`
`setForeground(Color fg)`
Sets the foreground color of this component.
`void`
`setInheritsPopupMenu(boolean value)`
Sets whether or not `getComponentPopupMenu` should delegate to the parent if this component does not have a `JPopupMenu` assigned to it.
`final void`
`setInputMap(int condition, InputMap map)`
Sets the `InputMap` to use under the condition `condition` to `map`.
`void`
`setInputVerifier(InputVerifier inputVerifier)`
Sets the input verifier for this component.
`void`
`setMaximumSize(Dimension maximumSize)`
Sets the maximum size of this component to a constant value.
`void`
`setMinimumSize(Dimension minimumSize)`
Sets the minimum size of this component to a constant value.
`void`
`setNextFocusableComponent(Component aComponent)`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`
`void`
`setOpaque(boolean isOpaque)`
If true the component paints every pixel within its bounds.
`void`
`setPreferredSize(Dimension preferredSize)`
Sets the preferred size of this component.
`void`
`setRequestFocusEnabled(boolean requestFocusEnabled)`
Provides a hint as to whether or not this `JComponent` should get focus.
`void`
`setToolTipText(String text)`
Registers the text to display in a tool tip.
`void`
`setTransferHandler(TransferHandler newHandler)`
Sets the `TransferHandler`, which provides support for transfer of data into and out of this component via cut/copy/paste and drag and drop.
`protected void`
`setUI(ComponentUI newUI)`
Sets the look and feel delegate for this component.
`void`
`setVerifyInputWhenFocusTarget(boolean verifyInputWhenFocusTarget)`
Sets the value to indicate whether input verifier for the current focus owner will be called before this component requests focus.
`void`
`setVisible(boolean aFlag)`
Makes the component visible or invisible.
`void`
`unregisterKeyboardAction(KeyStroke aKeyStroke)`
This method is now obsolete.
`void`
`update(Graphics g)`
Calls `paint`.

### Methods declared in class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`
Modifier and Type
Method
Description
`Component`
`add(Component comp)`
Appends the specified component to the end of this container.
`Component`
`add(Component comp, int index)`
Adds the specified component to this container at the given position.
`void`
`add(Component comp, Object constraints)`
Adds the specified component to the end of this container.
`void`
`add(Component comp, Object constraints, int index)`
Adds the specified component to this container with the specified constraints at the specified index.
`Component`
`add(String name, Component comp)`
Adds the specified component to this container.
`void`
`addContainerListener(ContainerListener l)`
Adds the specified container listener to receive container events from this container.
`protected void`
`addImpl(Component comp, Object constraints, int index)`
Adds the specified component to this container at the specified index.
`void`
`addPropertyChangeListener(PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list.
`void`
`addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list for a specific property.
`void`
`applyComponentOrientation(ComponentOrientation o)`
Sets the `ComponentOrientation` property of this container and all components contained within it.
`boolean`
`areFocusTraversalKeysSet(int id)`
Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Container.
`int`
`countComponents()`
Deprecated.
As of JDK version 1.1, replaced by getComponentCount().
`void`
`deliverEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`
`void`
`doLayout()`
Causes this container to lay out its components.
`Component`
`findComponentAt(int x, int y)`
Locates the visible child component that contains the specified position.
`Component`
`findComponentAt(Point p)`
Locates the visible child component that contains the specified point.
`Component`
`getComponent(int n)`
Gets the nth component in this container.
`Component`
`getComponentAt(int x, int y)`
Locates the component that contains the x,y position.
`Component`
`getComponentAt(Point p)`
Gets the component that contains the specified point.
`int`
`getComponentCount()`
Gets the number of components in this panel.
`Component[]`
`getComponents()`
Gets all the components in this container.
`int`
`getComponentZOrder(Component comp)`
Returns the z-order index of the component inside the container.
`ContainerListener[]`
`getContainerListeners()`
Returns an array of all the container listeners registered on this container.
`Set<AWTKeyStroke>`
`getFocusTraversalKeys(int id)`
Returns the Set of focus traversal keys for a given traversal operation for this Container.
`FocusTraversalPolicy`
`getFocusTraversalPolicy()`
Returns the focus traversal policy that will manage keyboard traversal of this Container's children, or null if this Container is not a focus cycle root.
`LayoutManager`
`getLayout()`
Gets the layout manager for this container.
`Point`
`getMousePosition(boolean allowChildren)`
Returns the position of the mouse pointer in this `Container`'s coordinate space if the `Container` is under the mouse pointer, otherwise returns `null`.
`Insets`
`insets()`
Deprecated.
As of JDK version 1.1, replaced by `getInsets()`.
`void`
`invalidate()`
Invalidates the container.
`boolean`
`isAncestorOf(Component c)`
Checks if the component is contained in the component hierarchy of this container.
`boolean`
`isFocusCycleRoot()`
Returns whether this Container is the root of a focus traversal cycle.
`boolean`
`isFocusCycleRoot(Container container)`
Returns whether the specified Container is the focus cycle root of this Container's focus traversal cycle.
`final boolean`
`isFocusTraversalPolicyProvider()`
Returns whether this container provides focus traversal policy.
`boolean`
`isFocusTraversalPolicySet()`
Returns whether the focus traversal policy has been explicitly set for this Container.
`void`
`layout()`
Deprecated.
As of JDK version 1.1, replaced by `doLayout()`.
`void`
`list(PrintStream out, int indent)`
Prints a listing of this container to the specified output stream.
`void`
`list(PrintWriter out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print writer.
`Component`
`locate(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `getComponentAt(int, int)`.
`Dimension`
`minimumSize()`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
`void`
`paintComponents(Graphics g)`
Paints each of the components in this container.
`Dimension`
`preferredSize()`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
`void`
`printComponents(Graphics g)`
Prints each of the components in this container.
`protected void`
`processContainerEvent(ContainerEvent e)`
Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
`protected void`
`processEvent(AWTEvent e)`
Processes events on this container.
`void`
`remove(int index)`
Removes the component, specified by `index`, from this container.
`void`
`remove(Component comp)`
Removes the specified component from this container.
`void`
`removeAll()`
Removes all the components from this container.
`void`
`removeContainerListener(ContainerListener l)`
Removes the specified container listener so it no longer receives container events from this container.
`void`
`setComponentZOrder(Component comp, int index)`
Moves the specified component to the specified z-order index in the container.
`void`
`setFocusCycleRoot(boolean focusCycleRoot)`
Sets whether this Container is the root of a focus traversal cycle.
`void`
`setFocusTraversalPolicy(FocusTraversalPolicy policy)`
Sets the focus traversal policy that will manage keyboard traversal of this Container's children, if this Container is a focus cycle root.
`final void`
`setFocusTraversalPolicyProvider(boolean provider)`
Sets whether this container will be used to provide focus traversal policy.
`void`
`setLayout(LayoutManager mgr)`
Sets the layout manager for this container.
`void`
`transferFocusDownCycle()`
Transfers the focus down one focus traversal cycle.
`void`
`validate()`
Validates this container and all of its subcomponents.
`protected void`
`validateTree()`
Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

### Methods declared in class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`
Modifier and Type
Method
Description
`boolean`
`action(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void`
`add(PopupMenu popup)`
Adds the specified popup menu to the component.
`void`
`addComponentListener(ComponentListener l)`
Adds the specified component listener to receive component events from this component.
`void`
`addFocusListener(FocusListener l)`
Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void`
`addHierarchyBoundsListener(HierarchyBoundsListener l)`
Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void`
`addHierarchyListener(HierarchyListener l)`
Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void`
`addInputMethodListener(InputMethodListener l)`
Adds the specified input method listener to receive input method events from this component.
`void`
`addKeyListener(KeyListener l)`
Adds the specified key listener to receive key events from this component.
`void`
`addMouseListener(MouseListener l)`
Adds the specified mouse listener to receive mouse events from this component.
`void`
`addMouseMotionListener(MouseMotionListener l)`
Adds the specified mouse motion listener to receive mouse motion events from this component.
`void`
`addMouseWheelListener(MouseWheelListener l)`
Adds the specified mouse wheel listener to receive mouse wheel events from this component.
`Rectangle`
`bounds()`
Deprecated.
As of JDK version 1.1, replaced by `getBounds()`.
`int`
`checkImage(Image image, int width, int height, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`int`
`checkImage(Image image, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent`
`coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
Potentially coalesce an event being posted with an existing event.
`boolean`
`contains(Point p)`
Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image`
`createImage(int width, int height)`
Creates an off-screen drawable image to be used for double buffering.
`Image`
`createImage(ImageProducer producer)`
Creates an image from the specified image producer.
`VolatileImage`
`createVolatileImage(int width, int height)`
Creates a volatile off-screen drawable image to be used for double buffering.
`VolatileImage`
`createVolatileImage(int width, int height, ImageCapabilities caps)`
Creates a volatile off-screen drawable image, with the given capabilities.
`protected final void`
`disableEvents(long eventsToDisable)`
Disables the events defined by the specified event mask parameter from being delivered to this component.
`final void`
`dispatchEvent(AWTEvent e)`
Dispatches an event to this component or one of its sub components.
`void`
`enable(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`enableEvents(long eventsToEnable)`
Enables the events defined by the specified event mask parameter to be delivered to this component.
`void`
`enableInputMethods(boolean enable)`
Enables or disables input method support for this component.
`void`
`firePropertyChange(String propertyName, byte oldValue, byte newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, char oldValue, char newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, double oldValue, double newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, float oldValue, float newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, long oldValue, long newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, short oldValue, short newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, Object oldValue, Object newValue)`
Support for reporting bound property changes for Object properties.
`Color`
`getBackground()`
Gets the background color of this component.
`Rectangle`
`getBounds()`
Gets the bounds of this component in the form of a `Rectangle` object.
`ColorModel`
`getColorModel()`
Gets the instance of `ColorModel` used to display the component on the output device.
`ComponentListener[]`
`getComponentListeners()`
Returns an array of all the component listeners registered on this component.
`ComponentOrientation`
`getComponentOrientation()`
Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor`
`getCursor()`
Gets the cursor set in the component.
`DropTarget`
`getDropTarget()`
Gets the `DropTarget` associated with this `Component`.
`Container`
`getFocusCycleRootAncestor()`
Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
`FocusListener[]`
`getFocusListeners()`
Returns an array of all the focus listeners registered on this component.
`boolean`
`getFocusTraversalKeysEnabled()`
Returns whether focus traversal keys are enabled for this Component.
`Font`
`getFont()`
Gets the font of this component.
`Color`
`getForeground()`
Gets the foreground color of this component.
`GraphicsConfiguration`
`getGraphicsConfiguration()`
Gets the `GraphicsConfiguration` associated with this `Component`.
`HierarchyBoundsListener[]`
`getHierarchyBoundsListeners()`
Returns an array of all the hierarchy bounds listeners registered on this component.
`HierarchyListener[]`
`getHierarchyListeners()`
Returns an array of all the hierarchy listeners registered on this component.
`boolean`
`getIgnoreRepaint()`
Returns whether or not paint messages received from the operating system should be ignored.
`InputContext`
`getInputContext()`
Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodListener[]`
`getInputMethodListeners()`
Returns an array of all the input method listeners registered on this component.
`KeyListener[]`
`getKeyListeners()`
Returns an array of all the key listeners registered on this component.
`Locale`
`getLocale()`
Gets the locale of this component.
`Point`
`getLocation()`
Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point`
`getLocationOnScreen()`
Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`MouseListener[]`
`getMouseListeners()`
Returns an array of all the mouse listeners registered on this component.
`MouseMotionListener[]`
`getMouseMotionListeners()`
Returns an array of all the mouse motion listeners registered on this component.
`Point`
`getMousePosition()`
Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
`MouseWheelListener[]`
`getMouseWheelListeners()`
Returns an array of all the mouse wheel listeners registered on this component.
`String`
`getName()`
Gets the name of the component.
`Container`
`getParent()`
Gets the parent of this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners()`
Returns an array of all the property change listeners registered on this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners(String propertyName)`
Returns an array of all the listeners which have been associated with the named property.
`Dimension`
`getSize()`
Returns the size of this component in the form of a `Dimension` object.
`Toolkit`
`getToolkit()`
Gets the toolkit of this component.
`final Object`
`getTreeLock()`
Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
`boolean`
`gotFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`handleEvent(Event evt)`
Deprecated.
As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean`
`hasFocus()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
Repaints the component when the image has changed.
`boolean`
`inside(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by contains(int, int).
`boolean`
`isBackgroundSet()`
Returns whether the background color has been explicitly set for this Component.
`boolean`
`isCursorSet()`
Returns whether the cursor has been explicitly set for this Component.
`boolean`
`isDisplayable()`
Determines whether this component is displayable.
`boolean`
`isEnabled()`
Determines whether this component is enabled.
`boolean`
`isFocusable()`
Returns whether this Component can be focused.
`boolean`
`isFocusOwner()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`isFocusTraversable()`
Deprecated.
As of 1.4, replaced by `isFocusable()`.
`boolean`
`isFontSet()`
Returns whether the font has been explicitly set for this Component.
`boolean`
`isForegroundSet()`
Returns whether the foreground color has been explicitly set for this Component.
`boolean`
`isLightweight()`
A lightweight component doesn't have a native toolkit peer.
`boolean`
`isMaximumSizeSet()`
Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
`boolean`
`isMinimumSizeSet()`
Returns whether or not `setMinimumSize` has been invoked with a non-null value.
`boolean`
`isPreferredSizeSet()`
Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
`boolean`
`isShowing()`
Determines whether this component is showing on screen.
`boolean`
`isValid()`
Determines whether this component is valid.
`boolean`
`isVisible()`
Determines whether this component should be visible when its parent is visible.
`boolean`
`keyDown(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean`
`keyUp(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void`
`list()`
Prints a listing of this component to the standard system output stream `System.out`.
`void`
`list(PrintStream out)`
Prints a listing of this component to the specified output stream.
`void`
`list(PrintWriter out)`
Prints a listing to the specified print writer.
`Point`
`location()`
Deprecated.
As of JDK version 1.1, replaced by `getLocation()`.
`boolean`
`lostFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`mouseDown(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseDrag(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseEnter(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseExit(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseMove(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseUp(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void`
`move(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void`
`nextFocus()`
Deprecated.
As of JDK version 1.1, replaced by transferFocus().
`void`
`paintAll(Graphics g)`
Paints this component and all of its subcomponents.
`boolean`
`postEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`boolean`
`prepareImage(Image image, int width, int height, ImageObserver observer)`
Prepares an image for rendering on this component at the specified width and height.
`boolean`
`prepareImage(Image image, ImageObserver observer)`
Prepares an image for rendering on this component.
`protected void`
`processComponentEvent(ComponentEvent e)`
Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void`
`processFocusEvent(FocusEvent e)`
Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void`
`processHierarchyBoundsEvent(HierarchyEvent e)`
Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void`
`processHierarchyEvent(HierarchyEvent e)`
Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void`
`processInputMethodEvent(InputMethodEvent e)`
Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void`
`processMouseWheelEvent(MouseWheelEvent e)`
Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
`void`
`remove(MenuComponent popup)`
Removes the specified popup menu from the component.
`void`
`removeComponentListener(ComponentListener l)`
Removes the specified component listener so that it no longer receives component events from this component.
`void`
`removeFocusListener(FocusListener l)`
Removes the specified focus listener so that it no longer receives focus events from this component.
`void`
`removeHierarchyBoundsListener(HierarchyBoundsListener l)`
Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void`
`removeHierarchyListener(HierarchyListener l)`
Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void`
`removeInputMethodListener(InputMethodListener l)`
Removes the specified input method listener so that it no longer receives input method events from this component.
`void`
`removeKeyListener(KeyListener l)`
Removes the specified key listener so that it no longer receives key events from this component.
`void`
`removeMouseListener(MouseListener l)`
Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void`
`removeMouseMotionListener(MouseMotionListener l)`
Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void`
`removeMouseWheelListener(MouseWheelListener l)`
Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
`void`
`removePropertyChangeListener(PropertyChangeListener listener)`
Removes a PropertyChangeListener from the listener list.
`void`
`removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Removes a `PropertyChangeListener` from the listener list for a specific property.
`void`
`repaint()`
Repaints this component.
`void`
`repaint(int x, int y, int width, int height)`
Repaints the specified rectangle of this component.
`void`
`repaint(long tm)`
Repaints the component.
`protected boolean`
`requestFocus(boolean temporary, FocusEvent.Cause cause)`
Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`void`
`requestFocus(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`requestFocusInWindow(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`void`
`resize(int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(int, int)`.
`void`
`resize(Dimension d)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void`
`setBounds(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`setBounds(Rectangle r)`
Moves and resizes this component to conform to the new bounding rectangle `r`.
`void`
`setComponentOrientation(ComponentOrientation o)`
Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
`void`
`setCursor(Cursor cursor)`
Sets the cursor image to the specified cursor.
`void`
`setDropTarget(DropTarget dt)`
Associate a `DropTarget` with this component.
`void`
`setFocusable(boolean focusable)`
Sets the focusable state of this Component to the specified value.
`void`
`setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
Sets whether focus traversal keys are enabled for this Component.
`void`
`setIgnoreRepaint(boolean ignoreRepaint)`
Sets whether or not paint messages received from the operating system should be ignored.
`void`
`setLocale(Locale l)`
Sets the locale of this component.
`void`
`setLocation(int x, int y)`
Moves this component to a new location.
`void`
`setLocation(Point p)`
Moves this component to a new location.
`void`
`setMixingCutoutShape(Shape shape)`
Sets a 'mixing-cutout' shape for this lightweight component.
`void`
`setName(String name)`
Sets the name of the component to the specified string.
`void`
`setSize(int width, int height)`
Resizes this component so that it has width `width` and height `height`.
`void`
`setSize(Dimension d)`
Resizes this component so that it has width `d.width` and height `d.height`.
`void`
`show()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`void`
`show(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension`
`size()`
Deprecated.
As of JDK version 1.1, replaced by `getSize()`.
`String`
`toString()`
Returns a string representation of this component and its values.
`void`
`transferFocus()`
Transfers the focus to the next component, as though this Component were the focus owner.
`void`
`transferFocusBackward()`
Transfers the focus to the previous component, as though this Component were the focus owner.
`void`
`transferFocusUpCycle()`
Transfers the focus up one focus traversal cycle.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### FOCUS_ACCELERATOR_KEY

public static final String FOCUS_ACCELERATOR_KEY
The bound property name for the focus accelerator.

See Also:
  - Constant Field Values

### DEFAULT_KEYMAP

public static final String DEFAULT_KEYMAP
The default keymap that will be shared by all `JTextComponent` instances unless they have had a different keymap set.

See Also:
  - Constant Field Values

## Constructor Details

### JTextComponent

public JTextComponent()
Creates a new `JTextComponent`. Listeners for caret events are established, and the pluggable UI installed. The component is marked as editable. No layout manager is used, because layout is managed by the view subsystem of text. The document model is set to `null`.

## Method Details

### getUI

public TextUI getUI()
Fetches the user-interface factory for this text-oriented editor.

Overrides:
  `getUI` in class `JComponent`
Returns:
  the factory

### setUI

public void setUI(TextUI ui)
Sets the user-interface factory for this text-oriented editor.

Parameters:
  `ui` - the factory

### updateUI

public void updateUI()
Reloads the pluggable UI. The key used to fetch the new interface is `getUIClassID()`. The type of the UI is `TextUI`. `invalidate` is called after setting the UI.

Overrides:
  `updateUI` in class `JComponent`
See Also:
  - `JComponent.setUI(ComponentUI)`
  - `UIManager.getLookAndFeel()`
  - `UIManager.getUI(JComponent)`

### addCaretListener

public void addCaretListener(CaretListener listener)
Adds a caret listener for notification of any changes to the caret.

Parameters:
  `listener` - the listener to be added
See Also:
  - `CaretEvent`

### removeCaretListener

public void removeCaretListener(CaretListener listener)
Removes a caret listener.

Parameters:
  `listener` - the listener to be removed
See Also:
  - `CaretEvent`

### getCaretListeners

@BeanProperty(bound=false) public CaretListener[] getCaretListeners()
Returns an array of all the caret listeners registered on this text component.

Returns:
  all of this component's `CaretListener`s or an empty array if no caret listeners are currently registered
Since:
  1.4
See Also:
  - `addCaretListener(CaretListener)`
  - `removeCaretListener(CaretListener)`

### fireCaretUpdate

protected void fireCaretUpdate(CaretEvent e)
Notifies all listeners that have registered interest for notification on this event type. The event instance is lazily created using the parameters passed into the fire method. The listener list is processed in a last-to-first manner.

Parameters:
  `e` - the event
See Also:
  - `EventListenerList`

### setDocument

@BeanProperty(expert=true, description="the text document model") public void setDocument(Document doc)
Associates the editor with a text document. The currently registered factory is used to build a view for the document, which gets displayed by the editor after revalidation. A PropertyChange event ("document") is propagated to each listener.

Parameters:
  `doc` - the document to display/edit
See Also:
  - `getDocument()`

### getDocument

public Document getDocument()
Fetches the model associated with the editor. This is primarily for the UI to get at the minimal amount of state required to be a text editor. Subclasses will return the actual type of the model which will typically be something that extends Document.

Returns:
  the model

### getActions

@BeanProperty(bound=false) public Action[] getActions()
Fetches the command list for the editor. This is the list of commands supported by the plugged-in UI augmented by the collection of commands that the editor itself supports. These are useful for binding to events, such as in a keymap.

Returns:
  the command list

### setMargin

@BeanProperty(description="desired space between the border and text area") public void setMargin(Insets m)
Sets margin space between the text component's border and its text. The text component's default `Border` object will use this value to create the proper margin. However, if a non-default border is set on the text component, it is that `Border` object's responsibility to create the appropriate margin space (else this property will effectively be ignored). This causes a redraw of the component. A PropertyChange event ("margin") is sent to all listeners.

Parameters:
  `m` - the space between the border and the text

### getMargin

public Insets getMargin()
Returns the margin between the text component's border and its text.

Returns:
  the margin

### setNavigationFilter

public void setNavigationFilter(NavigationFilter filter)
Sets the `NavigationFilter`. `NavigationFilter` is used by `DefaultCaret` and the default cursor movement actions as a way to restrict the cursor movement.

Parameters:
  `filter` - the filter
Since:
  1.4

### getNavigationFilter

public NavigationFilter getNavigationFilter()
Returns the `NavigationFilter`. `NavigationFilter` is used by `DefaultCaret` and the default cursor movement actions as a way to restrict the cursor movement. A null return value implies the cursor movement and selection should not be restricted.

Returns:
  the NavigationFilter
Since:
  1.4

### getCaret

public Caret getCaret()
Fetches the caret that allows text-oriented navigation over the view.

Returns:
  the caret

### setCaret

@BeanProperty(expert=true, description="the caret used to select/navigate") public void setCaret(Caret c)
Sets the caret to be used. By default this will be set by the UI that gets installed. This can be changed to a custom caret if desired. Setting the caret results in a PropertyChange event ("caret") being fired.

Parameters:
  `c` - the caret
See Also:
  - `getCaret()`

### getHighlighter

public Highlighter getHighlighter()
Fetches the object responsible for making highlights.

Returns:
  the highlighter

### setHighlighter

@BeanProperty(expert=true, description="object responsible for background highlights") public void setHighlighter(Highlighter h)
Sets the highlighter to be used. By default this will be set by the UI that gets installed. This can be changed to a custom highlighter if desired. The highlighter can be set to `null` to disable it. A PropertyChange event ("highlighter") is fired when a new highlighter is installed.

Parameters:
  `h` - the highlighter
See Also:
  - `getHighlighter()`

### setKeymap

@BeanProperty(description="set of key event to action bindings to use") public void setKeymap(Keymap map)
Sets the keymap to use for binding events to actions. Setting to `null` effectively disables keyboard input. A PropertyChange event ("keymap") is fired when a new keymap is installed.

Parameters:
  `map` - the keymap
See Also:
  - `getKeymap()`

### setDragEnabled

@BeanProperty(bound=false, description="determines whether automatic drag handling is enabled") public void setDragEnabled(boolean b)
Turns on or off automatic drag handling. In order to enable automatic drag handling, this property should be set to `true`, and the component's `TransferHandler` needs to be `non-null`. The default value of the `dragEnabled` property is `false`.

The job of honoring this property, and recognizing a user drag gesture, lies with the look and feel implementation, and in particular, the component's `TextUI`. When automatic drag handling is enabled, most look and feels (including those that subclass `BasicLookAndFeel`) begin a drag and drop operation whenever the user presses the mouse button over a selection and then moves the mouse a few pixels. Setting this property to `true` can therefore have a subtle effect on how selections behave.

If a look and feel is used that ignores this property, you can still begin a drag and drop operation by calling `exportAsDrag` on the component's `TransferHandler`.

Parameters:
  `b` - whether or not to enable automatic drag handling
Throws:
  `HeadlessException` - if `b` is `true` and `GraphicsEnvironment.isHeadless()` returns `true`
Since:
  1.4
See Also:
  - `GraphicsEnvironment.isHeadless()`
  - `getDragEnabled()`
  - `JComponent.setTransferHandler(TransferHandler)`
  - `TransferHandler`

### getDragEnabled

public boolean getDragEnabled()
Returns whether or not automatic drag handling is enabled.

Returns:
  the value of the `dragEnabled` property
Since:
  1.4
See Also:
  - `setDragEnabled(boolean)`

### setDropMode

public final void setDropMode(DropMode dropMode)
Sets the drop mode for this component. For backward compatibility, the default for this property is `DropMode.USE_SELECTION`. Usage of `DropMode.INSERT` is recommended, however, for an improved user experience. It offers similar behavior of dropping between text locations, but does so without affecting the actual text selection and caret location.

`JTextComponents` support the following drop modes:

- `DropMode.USE_SELECTION`
- `DropMode.INSERT`

The drop mode is only meaningful if this component has a `TransferHandler` that accepts drops.

Parameters:
  `dropMode` - the drop mode to use
Throws:
  `IllegalArgumentException` - if the drop mode is unsupported or `null`
Since:
  1.6
See Also:
  - `getDropMode()`
  - `getDropLocation()`
  - `JComponent.setTransferHandler(TransferHandler)`
  - `TransferHandler`

### getDropMode

public final DropMode getDropMode()
Returns the drop mode for this component.

Returns:
  the drop mode for this component
Since:
  1.6
See Also:
  - `setDropMode(DropMode)`

### getDropLocation

@BeanProperty(bound=false) public final JTextComponent.DropLocation getDropLocation()
Returns the location that this component should visually indicate as the drop location during a DnD operation over the component, or `null` if no location is to currently be shown.

This method is not meant for querying the drop location from a `TransferHandler`, as the drop location is only set after the `TransferHandler`'s `canImport` has returned and has allowed for the location to be shown.

When this property changes, a property change event with name "dropLocation" is fired by the component.

Returns:
  the drop location
Since:
  1.6
See Also:
  - `setDropMode(DropMode)`
  - `TransferHandler.canImport(TransferHandler.TransferSupport)`

### getKeymap

public Keymap getKeymap()
Fetches the keymap currently active in this text component.

Returns:
  the keymap

### addKeymap

public static Keymap addKeymap(String nm, Keymap parent)
Adds a new keymap into the keymap hierarchy. Keymap bindings resolve from bottom up so an attribute specified in a child will override an attribute specified in the parent.

Parameters:
  `nm` - the name of the keymap (must be unique within the collection of named keymaps in the document); the name may be `null` if the keymap is unnamed, but the caller is responsible for managing the reference returned as an unnamed keymap can't be fetched by name
  `parent` - the parent keymap; this may be `null` if unspecified bindings need not be resolved in some other keymap
Returns:
  the keymap

### removeKeymap

public static Keymap removeKeymap(String nm)
Removes a named keymap previously added to the document. Keymaps with `null` names may not be removed in this way.

Parameters:
  `nm` - the name of the keymap to remove
Returns:
  the keymap that was removed

### getKeymap

public static Keymap getKeymap(String nm)
Fetches a named keymap previously added to the document. This does not work with `null`-named keymaps.

Parameters:
  `nm` - the name of the keymap
Returns:
  the keymap

### loadKeymap

public static void loadKeymap(Keymap map, JTextComponent.KeyBinding[] bindings, Action[] actions)

Loads a keymap with a bunch of bindings. This can be used to take a static table of definitions and load them into some keymap. The following example illustrates an example of binding some keys to the cut, copy, and paste actions associated with a JTextComponent. A code fragment to accomplish this might look as follows:

      static final JTextComponent.KeyBinding[] defaultBindings = {
        new JTextComponent.KeyBinding(
          KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK),
          DefaultEditorKit.copyAction),
        new JTextComponent.KeyBinding(
          KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.CTRL_MASK),
          DefaultEditorKit.pasteAction),
        new JTextComponent.KeyBinding(
          KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK),
          DefaultEditorKit.cutAction),
      };

      JTextComponent c = new JTextPane();
      Keymap k = c.getKeymap();
      JTextComponent.loadKeymap(k, defaultBindings, c.getActions());

The sets of bindings and actions may be empty but must be non-`null`.

Parameters:
  `map` - the keymap
  `bindings` - the bindings
  `actions` - the set of actions

### getCaretColor

public Color getCaretColor()
Fetches the current color used to render the caret.

Returns:
  the color

### setCaretColor

@BeanProperty(preferred=true, description="the color used to render the caret") public void setCaretColor(Color c)
Sets the current color used to render the caret. Setting to `null` effectively restores the default color. Setting the color results in a PropertyChange event ("caretColor") being fired.

Parameters:
  `c` - the color
See Also:
  - `getCaretColor()`

### getSelectionColor

public Color getSelectionColor()
Fetches the current color used to render the selection.

Returns:
  the color

### setSelectionColor

@BeanProperty(preferred=true, description="color used to render selection background") public void setSelectionColor(Color c)
Sets the current color used to render the selection. Setting the color to `null` is the same as setting `Color.white`. Setting the color results in a PropertyChange event ("selectionColor").

Parameters:
  `c` - the color
See Also:
  - `getSelectionColor()`

### getSelectedTextColor

public Color getSelectedTextColor()
Fetches the current color used to render the selected text.

Returns:
  the color

### setSelectedTextColor

@BeanProperty(preferred=true, description="color used to render selected text") public void setSelectedTextColor(Color c)
Sets the current color used to render the selected text. Setting the color to `null` is the same as `Color.black`. Setting the color results in a PropertyChange event ("selectedTextColor") being fired.

Parameters:
  `c` - the color
See Also:
  - `getSelectedTextColor()`

### getDisabledTextColor

public Color getDisabledTextColor()
Fetches the current color used to render the disabled text.

Returns:
  the color

### setDisabledTextColor

@BeanProperty(preferred=true, description="color used to render disabled text") public void setDisabledTextColor(Color c)
Sets the current color used to render the disabled text. Setting the color fires off a PropertyChange event ("disabledTextColor").

Parameters:
  `c` - the color
See Also:
  - `getDisabledTextColor()`

### replaceSelection

public void replaceSelection(String content)
Replaces the currently selected content with new content represented by the given string. If there is no selection this amounts to an insert of the given text. If there is no replacement text this amounts to a removal of the current selection.

This is the method that is used by the default implementation of the action for inserting content that gets bound to the keymap actions.

Parameters:
  `content` - the content to replace the selection with

### getText

public String getText(int offs, int len) throws BadLocationException
Fetches a portion of the text represented by the component. Returns an empty string if length is 0.

Parameters:
  `offs` - the offset ≥ 0
  `len` - the length ≥ 0
Returns:
  the text
Throws:
  `BadLocationException` - if the offset or length are invalid

### modelToView

@Deprecated(since="9") public Rectangle modelToView(int pos) throws BadLocationException
Deprecated.
replaced by `modelToView2D(int)`
Converts the given location in the model to a place in the view coordinate system. The component must have a positive size for this translation to be computed (i.e. layout cannot be computed until the component has been sized). The component does not have to be visible or painted.

Parameters:
  `pos` - the position ≥ 0
Returns:
  the coordinates as a rectangle, with (r.x, r.y) as the location in the coordinate system, or null if the component does not yet have a positive size.
Throws:
  `BadLocationException` - if the given position does not represent a valid location in the associated document
See Also:
  - `TextUI.modelToView(JTextComponent, int)`

### modelToView2D

public Rectangle2D modelToView2D(int pos) throws BadLocationException
Converts the given location in the model to a place in the view coordinate system. The component must have a positive size for this translation to be computed (i.e. layout cannot be computed until the component has been sized). The component does not have to be visible or painted.

Parameters:
  `pos` - the position `>= 0`
Returns:
  the coordinates as a rectangle, with (r.x, r.y) as the location in the coordinate system, or null if the component does not yet have a positive size.
Throws:
  `BadLocationException` - if the given position does not represent a valid location in the associated document
Since:
  9
See Also:
  - `TextUI.modelToView2D(JTextComponent, int, Position.Bias)`

### viewToModel

@Deprecated(since="9") public int viewToModel(Point pt)
Deprecated.
replaced by `viewToModel2D(Point2D)`
Converts the given place in the view coordinate system to the nearest representative location in the model. The component must have a positive size for this translation to be computed (i.e. layout cannot be computed until the component has been sized). The component does not have to be visible or painted.

Parameters:
  `pt` - the location in the view to translate
Returns:
  the offset ≥ 0 from the start of the document, or -1 if the component does not yet have a positive size.
See Also:
  - `TextUI.viewToModel(JTextComponent, Point)`

### viewToModel2D

public int viewToModel2D(Point2D pt)
Converts the given place in the view coordinate system to the nearest representative location in the model. The component must have a positive size for this translation to be computed (i.e. layout cannot be computed until the component has been sized). The component does not have to be visible or painted.

Parameters:
  `pt` - the location in the view to translate
Returns:
  the offset `>= 0` from the start of the document, or `-1` if the component does not yet have a positive size.
Since:
  9
See Also:
  - `TextUI.viewToModel2D(JTextComponent, Point2D, Position.Bias[])`

### cut

public void cut()
Transfers the currently selected range in the associated text model to the system clipboard, removing the contents from the model. The current selection is reset. Does nothing for `null` selections.

See Also:
  - `Toolkit.getSystemClipboard()`
  - `Clipboard`

### copy

public void copy()
Transfers the currently selected range in the associated text model to the system clipboard, leaving the contents in the text model. The current selection remains intact. Does nothing for `null` selections.

See Also:
  - `Toolkit.getSystemClipboard()`
  - `Clipboard`

### paste

public void paste()
Transfers the contents of the system clipboard into the associated text model. If there is a selection in the associated view, it is replaced with the contents of the clipboard. If there is no selection, the clipboard contents are inserted in front of the current insert position in the associated view. If the clipboard is empty, does nothing.

See Also:
  - `replaceSelection(String)`
  - `Toolkit.getSystemClipboard()`
  - `Clipboard`

### moveCaretPosition

public void moveCaretPosition(int pos)
Moves the caret to a new position, leaving behind a mark defined by the last time `setCaretPosition` was called. This forms a selection. If the document is `null`, does nothing. The position must be between 0 and the length of the component's text or else an exception is thrown.

Parameters:
  `pos` - the position
Throws:
  `IllegalArgumentException` - if the value supplied for `position` is less than zero or greater than the component's text length
See Also:
  - `setCaretPosition(int)`

### setFocusAccelerator

@BeanProperty(description="accelerator character used to grab focus") public void setFocusAccelerator(char aKey)
Sets the key accelerator that will cause the receiving text component to get the focus. The accelerator will be the key combination of the platform-specific modifier key and the character given (converted to upper case). For example, the ALT key is used as a modifier on Windows and the CTRL+ALT combination is used on Mac. By default, there is no focus accelerator key. Any previous key accelerator setting will be superseded. A '\0' key setting will be registered, and has the effect of turning off the focus accelerator. When the new key is set, a PropertyChange event (FOCUS_ACCELERATOR_KEY) will be fired.

Parameters:
  `aKey` - the key
See Also:
  - `getFocusAccelerator()`

### getFocusAccelerator

public char getFocusAccelerator()
Returns the key accelerator that will cause the receiving text component to get the focus. Return '\0' if no focus accelerator has been set.

Returns:
  the key

### read

public void read(Reader in, Object desc) throws IOException
Initializes from a stream. This creates a model of the type appropriate for the component and initializes the model from the stream. By default this will load the model as plain text. Previous contents of the model are discarded.

Parameters:
  `in` - the stream to read from
  `desc` - an object describing the stream; this might be a string, a File, a URL, etc. Some kinds of documents (such as html for example) might be able to make use of this information; if non-`null`, it is added as a property of the document
Throws:
  `IOException` - as thrown by the stream being used to initialize
See Also:
  - `EditorKit.createDefaultDocument()`
  - `setDocument(Document)`
  - `PlainDocument`

### write

public void write(Writer out) throws IOException
Stores the contents of the model into the given stream. By default this will store the model as plain text.

Parameters:
  `out` - the output stream
Throws:
  `IOException` - on any I/O error

### setCaretPosition

@BeanProperty(bound=false, description="the caret position") public void setCaretPosition(int position)
Sets the position of the text insertion caret for the `TextComponent`. Note that the caret tracks change, so this may move if the underlying text of the component is changed. If the document is `null`, does nothing. The position must be between 0 and the length of the component's text or else an exception is thrown.

Parameters:
  `position` - the position
Throws:
  `IllegalArgumentException` - if the value supplied for `position` is less than zero or greater than the component's text length

### getCaretPosition

public int getCaretPosition()
Returns the position of the text insertion caret for the text component.

Returns:
  the position of the text insertion caret for the text component ≥ 0

### setText

@BeanProperty(bound=false, description="the text of this component") public void setText(String t)
Sets the text of this `TextComponent` to the specified text. If the text is `null` or empty, has the effect of simply deleting the old text. When text has been inserted, the resulting caret location is determined by the implementation of the caret class.

Note that text is not a bound property, so no `PropertyChangeEvent` is fired when it changes. To listen for changes to the text, use `DocumentListener`.

Parameters:
  `t` - the new text to be set
See Also:
  - `getText(int, int)`
  - `DefaultCaret`

### getText

public String getText()
Returns the text contained in this `TextComponent`. If the underlying document is `null`, will give a `NullPointerException`. Note that text is not a bound property, so no `PropertyChangeEvent` is fired when it changes. To listen for changes to the text, use `DocumentListener`.

Returns:
  the text
Throws:
  `NullPointerException` - if the document is `null`
See Also:
  - `setText(String)`

### getSelectedText

@BeanProperty(bound=false) public String getSelectedText()
Returns the selected text contained in this `TextComponent`. If the selection is `null` or the document empty, returns `null`.

Returns:
  the text
Throws:
  `IllegalArgumentException` - if the selection doesn't have a valid mapping into the document for some reason
See Also:
  - `setText(String)`

### isEditable

public boolean isEditable()
Returns the boolean indicating whether this `TextComponent` is editable or not.

Returns:
  the boolean value
See Also:
  - `setEditable(boolean)`

### setEditable

@BeanProperty(description="specifies if the text can be edited") public void setEditable(boolean b)
Sets the specified boolean to indicate whether or not this `TextComponent` should be editable. A PropertyChange event ("editable") is fired when the state is changed.

Parameters:
  `b` - the boolean to be set
See Also:
  - `isEditable()`

### getSelectionStart

public int getSelectionStart()
Returns the selected text's start position. Return 0 for an empty document, or the value of dot if no selection.

Returns:
  the start position ≥ 0

### setSelectionStart

@BeanProperty(bound=false, description="starting location of the selection.") public void setSelectionStart(int selectionStart)
Sets the selection start to the specified position. The new starting point is constrained to be before or at the current selection end.

This is available for backward compatibility to code that called this method on `java.awt.TextComponent`. This is implemented to forward to the `Caret` implementation which is where the actual selection is maintained.

Parameters:
  `selectionStart` - the start position of the text ≥ 0

### getSelectionEnd

public int getSelectionEnd()
Returns the selected text's end position. Return 0 if the document is empty, or the value of dot if there is no selection.

Returns:
  the end position ≥ 0

### setSelectionEnd

@BeanProperty(bound=false, description="ending location of the selection.") public void setSelectionEnd(int selectionEnd)
Sets the selection end to the specified position. The new end point is constrained to be at or after the current selection start.

This is available for backward compatibility to code that called this method on `java.awt.TextComponent`. This is implemented to forward to the `Caret` implementation which is where the actual selection is maintained.

Parameters:
  `selectionEnd` - the end position of the text ≥ 0

### select

public void select(int selectionStart, int selectionEnd)
Selects the text between the specified start and end positions.

This method sets the start and end positions of the selected text, enforcing the restriction that the start position must be greater than or equal to zero. The end position must be greater than or equal to the start position, and less than or equal to the length of the text component's text.

If the caller supplies values that are inconsistent or out of bounds, the method enforces these constraints silently, and without failure. Specifically, if the start position or end position is greater than the length of the text, it is reset to equal the text length. If the start position is less than zero, it is reset to zero, and if the end position is less than the start position, it is reset to the start position.

This call is provided for backward compatibility. It is routed to a call to `setCaretPosition` followed by a call to `moveCaretPosition`. The preferred way to manage selection is by calling those methods directly.

Parameters:
  `selectionStart` - the start position of the text
  `selectionEnd` - the end position of the text
See Also:
  - `setCaretPosition(int)`
  - `moveCaretPosition(int)`

### selectAll

public void selectAll()
Selects all the text in the `TextComponent`. Does nothing on a `null` or empty document.

### getToolTipText

public String getToolTipText(MouseEvent event)
Returns the string to be used as the tooltip for `event`. This will return one of:

1. If `setToolTipText` has been invoked with a non-`null` value, it will be returned, otherwise
2. The value from invoking `getToolTipText` on the UI will be returned.

By default `JTextComponent` does not register itself with the `ToolTipManager`. This means that tooltips will NOT be shown from the `TextUI` unless `registerComponent` has been invoked on the `ToolTipManager`.

Overrides:
  `getToolTipText` in class `JComponent`
Parameters:
  `event` - the event in question
Returns:
  the string to be used as the tooltip for `event`
See Also:
  - `JComponent.setToolTipText(String)`
  - `TextUI.getToolTipText(JTextComponent, Point)`
  - `ToolTipManager.registerComponent(JComponent)`

### getPreferredScrollableViewportSize

@BeanProperty(bound=false) public Dimension getPreferredScrollableViewportSize()
Returns the preferred size of the viewport for a view component. This is implemented to do the default behavior of returning the preferred size of the component.

Specified by:
  `getPreferredScrollableViewportSize` in interface `Scrollable`
Returns:
  the `preferredSize` of a `JViewport` whose view is this `Scrollable`
See Also:
  - `JComponent.getPreferredSize()`

### getScrollableUnitIncrement

public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction)
Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation. Ideally, components should handle a partially exposed row or column by returning the distance required to completely expose the item.

The default implementation of this is to simply return 10% of the visible area. Subclasses are likely to be able to provide a much more reasonable value.

Specified by:
  `getScrollableUnitIncrement` in interface `Scrollable`
Parameters:
  `visibleRect` - the view area visible within the viewport
  `orientation` - either `SwingConstants.VERTICAL` or `SwingConstants.HORIZONTAL`
  `direction` - less than zero to scroll up/left, greater than zero for down/right
Returns:
  the "unit" increment for scrolling in the specified direction
Throws:
  `IllegalArgumentException` - for an invalid orientation
See Also:
  - `JScrollBar.setUnitIncrement(int)`

### getScrollableBlockIncrement

public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction)
Components that display logical rows or columns should compute the scroll increment that will completely expose one block of rows or columns, depending on the value of orientation.

The default implementation of this is to simply return the visible area. Subclasses will likely be able to provide a much more reasonable value.

Specified by:
  `getScrollableBlockIncrement` in interface `Scrollable`
Parameters:
  `visibleRect` - the view area visible within the viewport
  `orientation` - either `SwingConstants.VERTICAL` or `SwingConstants.HORIZONTAL`
  `direction` - less than zero to scroll up/left, greater than zero for down/right
Returns:
  the "block" increment for scrolling in the specified direction
Throws:
  `IllegalArgumentException` - for an invalid orientation
See Also:
  - `JScrollBar.setBlockIncrement(int)`

### getScrollableTracksViewportWidth

@BeanProperty(bound=false) public boolean getScrollableTracksViewportWidth()
Returns true if a viewport should always force the width of this `Scrollable` to match the width of the viewport. For example a normal text view that supported line wrapping would return true here, since it would be undesirable for wrapped lines to disappear beyond the right edge of the viewport. Note that returning true for a `Scrollable` whose ancestor is a `JScrollPane` effectively disables horizontal scrolling.

Scrolling containers, like `JViewport`, will use this method each time they are validated.

Specified by:
  `getScrollableTracksViewportWidth` in interface `Scrollable`
Returns:
  true if a viewport should force the `Scrollable`s width to match its own

### getScrollableTracksViewportHeight

@BeanProperty(bound=false) public boolean getScrollableTracksViewportHeight()
Returns true if a viewport should always force the height of this `Scrollable` to match the height of the viewport. For example a columnar text view that flowed text in left to right columns could effectively disable vertical scrolling by returning true here.

Scrolling containers, like `JViewport`, will use this method each time they are validated.

Specified by:
  `getScrollableTracksViewportHeight` in interface `Scrollable`
Returns:
  true if a viewport should force the Scrollables height to match its own

### print

public boolean print() throws PrinterException
A convenience print method that displays a print dialog, and then prints this `JTextComponent` in interactive mode with no header or footer text. Note: this method blocks until printing is done.

Note: In headless mode, no dialogs will be shown.

This method calls the full featured `print` method to perform printing.

Returns:
  `true`, unless printing is canceled by the user
Throws:
  `PrinterException` - if an error in the print system causes the job to be aborted
Since:
  1.6
See Also:
  - `print(MessageFormat, MessageFormat, boolean, PrintService, PrintRequestAttributeSet, boolean)`

### print

public boolean print(MessageFormat headerFormat, MessageFormat footerFormat) throws PrinterException
A convenience print method that displays a print dialog, and then prints this `JTextComponent` in interactive mode with the specified header and footer text. Note: this method blocks until printing is done.

Note: In headless mode, no dialogs will be shown.

This method calls the full featured `print` method to perform printing.

Parameters:
  `headerFormat` - the text, in `MessageFormat`, to be used as the header, or `null` for no header
  `footerFormat` - the text, in `MessageFormat`, to be used as the footer, or `null` for no footer
Returns:
  `true`, unless printing is canceled by the user
Throws:
  `PrinterException` - if an error in the print system causes the job to be aborted
Since:
  1.6
See Also:
  - `print(MessageFormat, MessageFormat, boolean, PrintService, PrintRequestAttributeSet, boolean)`
  - `MessageFormat`

### print

public boolean print(MessageFormat headerFormat, MessageFormat footerFormat, boolean showPrintDialog, PrintService service, PrintRequestAttributeSet attributes, boolean interactive) throws PrinterException
Prints the content of this `JTextComponent`. Note: this method blocks until printing is done.

Page header and footer text can be added to the output by providing `MessageFormat` arguments. The printing code requests `Strings` from the formats, providing a single item which may be included in the formatted string: an `Integer` representing the current page number.

`showPrintDialog boolean` parameter allows you to specify whether a print dialog is displayed to the user. When it is, the user may use the dialog to change printing attributes or even cancel the print.

`service` allows you to provide the initial `PrintService` for the print dialog, or to specify `PrintService` to print to when the dialog is not shown.

`attributes` can be used to provide the initial values for the print dialog, or to supply any needed attributes when the dialog is not shown. `attributes` can be used to control how the job will print, for example duplex or single-sided.

`interactive boolean` parameter allows you to specify whether to perform printing in interactive mode. If `true`, a progress dialog, with an abort option, is displayed for the duration of printing. This dialog is modal when `print` is invoked on the Event Dispatch Thread and non-modal otherwise. Warning: calling this method on the Event Dispatch Thread with `interactive false` blocks all events, including repaints, from being processed until printing is complete. It is only recommended when printing from an application with no visible GUI.

Note: In headless mode, `showPrintDialog` and `interactive` parameters are ignored and no dialogs are shown.

This method ensures the `document` is not mutated during printing. To indicate it visually, `setEnabled(false)` is set for the duration of printing.

This method uses `getPrintable(MessageFormat, MessageFormat)` to render document content.

This method is thread-safe, although most Swing methods are not. Please see Concurrency in Swing for more information.

Sample Usage. This code snippet shows a cross-platform print dialog and then prints the `JTextComponent` in interactive mode unless the user cancels the dialog:

    textComponent.print(new MessageFormat("My text component header"),
        new MessageFormat("Footer. Page - {0}"), true, null, null, true);

Executing this code off the Event Dispatch Thread performs printing on the background. The following pattern might be used for background printing:

        FutureTask<Boolean> future =
            new FutureTask<Boolean>(
                new Callable<Boolean>() {
                    public Boolean call() {
                        return textComponent.print(.....);
                    }
                });
        executor.execute(future);

Parameters:
  `headerFormat` - the text, in `MessageFormat`, to be used as the header, or `null` for no header
  `footerFormat` - the text, in `MessageFormat`, to be used as the footer, or `null` for no footer
  `showPrintDialog` - `true` to display a print dialog, `false` otherwise
  `service` - initial `PrintService`, or `null` for the default
  `attributes` - the job attributes to be applied to the print job, or `null` for none
  `interactive` - whether to print in an interactive mode
Returns:
  `true`, unless printing is canceled by the user
Throws:
  `PrinterException` - if an error in the print system causes the job to be aborted
Since:
  1.6
See Also:
  - `getPrintable(MessageFormat, MessageFormat)`
  - `MessageFormat`
  - `GraphicsEnvironment.isHeadless()`
  - `FutureTask`

### getPrintable

public Printable getPrintable(MessageFormat headerFormat, MessageFormat footerFormat)
Returns a `Printable` to use for printing the content of this `JTextComponent`. The returned `Printable` prints the document as it looks on the screen except being reformatted to fit the paper. The returned `Printable` can be wrapped inside another `Printable` in order to create complex reports and documents.

The returned `Printable` shares the `document` with this `JTextComponent`. It is the responsibility of the developer to ensure that the `document` is not mutated while this `Printable` is used. Printing behavior is undefined when the `document` is mutated during printing.

Page header and footer text can be added to the output by providing `MessageFormat` arguments. The printing code requests `Strings` from the formats, providing a single item which may be included in the formatted string: an `Integer` representing the current page number.

The returned `Printable` when printed, formats the document content appropriately for the page size. For correct line wrapping the `imageable width` of all pages must be the same. See `PageFormat.getImageableWidth()`.

This method is thread-safe, although most Swing methods are not. Please see Concurrency in Swing for more information.

The returned `Printable` can be printed on any thread.

This implementation returned `Printable` performs all painting on the Event Dispatch Thread, regardless of what thread it is used on.

Parameters:
  `headerFormat` - the text, in `MessageFormat`, to be used as the header, or `null` for no header
  `footerFormat` - the text, in `MessageFormat`, to be used as the footer, or `null` for no footer
Returns:
  a `Printable` for use in printing content of this `JTextComponent`
Since:
  1.6
See Also:
  - `Printable`
  - `PageFormat`
  - `Document.render(java.lang.Runnable)`

### getAccessibleContext

@BeanProperty(bound=false) public AccessibleContext getAccessibleContext()
Gets the `AccessibleContext` associated with this `JTextComponent`. For text components, the `AccessibleContext` takes the form of an `AccessibleJTextComponent`. A new `AccessibleJTextComponent` instance is created if necessary.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `Component`
Returns:
  an `AccessibleJTextComponent` that serves as the `AccessibleContext` of this `JTextComponent`

### paramString

protected String paramString()
Returns a string representation of this `JTextComponent`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

Overriding `paramString` to provide information about the specific new aspects of the JFC components.

Overrides:
  `paramString` in class `JComponent`
Returns:
  a string representation of this `JTextComponent`

### getInputMethodRequests

@BeanProperty(bound=false) public InputMethodRequests getInputMethodRequests()
Description copied from class: `Component`
Gets the input method request handler which supports requests from input methods for this component. A component that supports on-the-spot text input must override this method to return an `InputMethodRequests` instance. At the same time, it also has to handle input method events.

Overrides:
  `getInputMethodRequests` in class `Component`
Returns:
  the input method request handler for this component, `null` by default
See Also:
  - `Component.addInputMethodListener(InputMethodListener)`

### saveComposedText

protected boolean saveComposedText(int pos)
Saves composed text around the specified position. The composed text (if any) around the specified position is saved in a backing store and removed from the document.

Parameters:
  `pos` - document position to identify the composed text location
Returns:
  `true` if the composed text exists and is saved, `false` otherwise
Since:
  1.7
See Also:
  - `restoreComposedText()`

### restoreComposedText

protected void restoreComposedText()
Restores composed text previously saved by `saveComposedText`. The saved composed text is inserted back into the document. This method should be invoked only if `saveComposedText` returns `true`.

Since:
  1.7
See Also:
  - `saveComposedText(int)`